﻿// описываем какие именно части сторонних библиотек будем использовать (Глва 16)

using System;

// нужно для использования типа Dictionary
using System.Collections.Generic;

// нужно для использования типа Security
using Ecng.Trading.BusinessEntities;

// нужно для использования типа QuikTrader
using Ecng.Trading.Quik;

namespace Begin
{
	class Program
	{
		// Main - входная точка в программу
		static void Main(string[] args)
		{
			// 1. создаем переменную trader, имеющая тип QuikTrader
			// 2. создаем сложный объект типа QuikTrader (new - ключевое слово создания сложных объектов)
			// 3. присваиваем через знак "=" значение созданное на этапе 2 в переменную trader.
			// Глава 3, стр 147-155, 166-171
			QuikTrader trader = new QuikTrader();

			// аналогично переменной trader, создаем переменную dict, куда будут записываться все инструменты.
			// dict является словарем, где ключем является код инструмента, а значением сам инструмент.
			var dict = new Dictionary<string, Security>();

			// создаем переменную lkoh типа Security и инициализируем ее пустым значением null.
			Security lkoh = null;

			// подписываемся на событие успешного подключения
			// Глава 15, 494-504, 488-494
			trader.Connected += () =>
			{
				// выводим в консоль сообщение
				// стр 155-166, 260-268
				Console.WriteLine("Успешное подключение");

				// тело обработчика события Connected, где мы вызываем запуск экспорта
				// стр 155-166
				trader.StartExport();
			};

			// подписываемся на событие появление новых инструментов
			// в отличие от Connected, событие NewSecurities передает коллекцию новых инструментов ввиде параметра securities
			// Глава 15, 494-504, 488-494
			trader.NewSecurities += (securities) =>
			{
				// выводим в консоль сообщение
				// стр 155-166, 260-268
				Console.WriteLine("Новые инструменты");

				// перебираем в цикле foreach все инструменты
				// стр 129-142
				foreach (Security security in securities)
				{
					// стр 155-166, 260-268, 812-813
					Console.WriteLine("{0} {1}", security.Name, security.Code);

					// добавляем инструмент в слова dict
					dict.Add(security.Code, security);

					// если наш инструмент является Лукойлом
					// стр 121-129
					if (security.Code == "LKOH")
					{
						// присваиваем переменной lkoh
						lkoh = security;
					}
				}
			};

			// стр 155-166
			trader.Connect();

			// стр 155-166, 260-268
			Console.ReadLine();

			// удаляем явно из памяти переменную trader (остановка экспорта + отсоединение)
			trader.Dispose();
		}
	}
}
